Index: palm/trunk/SOURCE/date_and_time_mod.f90
===================================================================
--- palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3454)
+++ palm/trunk/SOURCE/date_and_time_mod.f90	(revision 3458)
@@ -19,5 +19,5 @@
 !
 ! Current revisions:
-! -----------------
+! ------------------
 ! 
 ! 
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, banzhafs:
+! Added initial hour_of_day, hour_of_year, day_of_year and month_of_year to
+! init_date_and_time
+!
+! 3298 2018-10-02 12:21:11Z kanani
 ! - Minor formatting (kanani)
 ! - Added Routines for DEFAULT mode of chemistry emissions (Russo)
@@ -61,4 +66,5 @@
 !>       already implemented changes for calculating it from date_init in 
 !>       calc_date_and_time
+!> @todo time_utc during spin-up  
 !------------------------------------------------------------------------------!
  MODULE date_and_time_mod
@@ -91,5 +97,6 @@
     INTEGER(iwp)        ::  index_mm                                !< index months of the default emission mode
     INTEGER(iwp)        ::  index_dd                                !< index days of the default emission mode
-    INTEGER(iwp)        ::  index_hh                                !< index hours of the default emission mode
+    INTEGER(iwp)        ::  index_hh                                !< index hours of the emission mode
+    INTEGER(iwp)        ::  hours_since_reference_point             !< hours of current simulation
 
     REAL(wp)            ::  time_utc                     !< current model time in UTC
@@ -102,5 +109,5 @@
     REAL(wp), PARAMETER ::  d_seconds_year = 1.0_wp / 31536000.0_wp !< inverse of the seconds per year (1/(365*86400))
     
-    CHARACTER(len=8)    ::  date_init = "31122018"                  !< Starting date of simulation: We selected this because it was a monday
+    CHARACTER(len=8)    ::  date_init = "21062017"                  !< Starting date of simulation: We selected this because it was a monday
  
     !> --- Parameters
@@ -121,4 +128,10 @@
     END INTERFACE time_default_indices
 
+    !-- Get hour index in the PRE-PROCESSED case of chemistry emissions :
+    INTERFACE time_preprocessed_indices
+       MODULE PROCEDURE time_preprocessed_indices
+    END INTERFACE time_preprocessed_indices
+
+
     !-- Calculate current date and time
     INTERFACE calc_date_and_time
@@ -128,5 +141,5 @@
 
     !-- Public Interfaces
-    PUBLIC calc_date_and_time, time_default_indices, init_date_and_time
+    PUBLIC calc_date_and_time, time_default_indices, init_date_and_time, time_preprocessed_indices
 
     !-- Public Variables
@@ -147,4 +160,7 @@
        IMPLICIT NONE
 
+       !--    Variables Definition
+       INTEGER ::  i_mon       !< Index for going through the different months
+
        IF  (day_of_year_init == 0) THEN
           ! Day of the month at starting time
@@ -159,34 +175,10 @@
        ENDIF
 
-    END SUBROUTINE init_date_and_time
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Calculate current date and time of the simulation 
-!------------------------------------------------------------------------------!
- 
-    SUBROUTINE calc_date_and_time
-
-       IMPLICIT NONE
-
-!--    Variables Definition
-       INTEGER		   		:: i_mon       !< Index for going through the different months
-
-       !> Update simulation time in seconds
-       time_update = simulated_time-coupling_start_time
-
-!--    Calculate current day of the simulated time
-       days_since_reference_point=INT(FLOOR( (time_utc_init + time_update) &
-                               / 86400.0_wp ) )
-
-!--    Calculate actual UTC time                        
-       time_utc = MOD((time_utc_init + time_since_reference_point), 86400.0_wp)
-       
-!sB    PRILIMINARY workaround for time_utc bug concerning time_since_reference_point:
-       time_utc_emis = MOD((time_utc_init + time_update), 86400.0_wp)     
-
-!--    Calculate initial day of the year: it is calculated only once. In fact, day_of_year_init is initialized to 0 and then a positive value is passed. This condition is also called only when day_of_year_init is not given in the namelist. 
-
+
+       !-- Calculate initial hour of the day: the first hour of the day is from 00:00:00 to 00:59:59. 
+
+       hour_of_day = INT( FLOOR( time_utc_init/3600.0_wp ) ) + 1
+
+       !-- Calculate initial day day_of_year_init in case date_init is given or day_of_year_init is given
        IF ( day_of_year_init == 0 ) THEN
 
@@ -214,4 +206,132 @@
        ENDIF
 
+       
+       !-- Initial day of the year
+       day_of_year = day_of_year_init
+
+       !-- Initial hour of the year
+       hour_of_year = ( (day_of_year-1) * 24 ) + hour_of_day
+
+       !--Initial day of the month and month of the year
+       !> --------------------------------------------------------------------------------
+       !> The first case is when date_init is not provided: we only know day_of_year_init      
+       IF ( month_of_year == 0 .AND. day_of_month == 0) THEN
+
+         
+          IF ( day_of_year .LE. 31 ) THEN
+
+             month_of_year=1
+             day_of_month=day_of_year
+
+          ELSE
+
+             DO i_mon=2,12   !january is considered in the first case
+                IF ( day_of_year .LE. SUM(days(1:i_mon)) .AND. day_of_year .GT. SUM(days(1:(i_mon-1))) ) THEN
+           
+                   month_of_year=i_mon
+
+                   day_of_month=INT(MOD(day_of_year, SUM(days(1:(i_mon-1))))) 
+
+                   GOTO 38
+
+                ENDIF
+
+             38 ENDDO
+          ENDIF
+       !> --------------------------------------------------------------------------------
+       !> in the second condition both day of month and month_of_year are either given in input (passed to date_init) or we are in some day successive to the initial one, so that day_of_month has already be computed in previous step
+       !>TBD: something to calculate the current year is missing
+       ELSEIF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+ 
+          !> calculate month_of_year. TBD: test the condition when day_of_year==31
+ 
+          IF (day_of_year==1) THEN  !> this allows to turn from december to January when passing from a year to another
+ 
+             month_of_year = 1
+        
+          ELSE IF (day_of_year .GT. 1 .AND. day_of_year .GT. SUM(days(1:month_of_year))) THEN
+
+             month_of_year = month_of_year + 1
+
+          ENDIF
+
+          !> calculate day_of_month
+          IF ( month_of_year == 1 ) THEN
+           
+            day_of_month=day_of_year
+
+          ELSE
+
+            day_of_month=INT(MOD(day_of_year, SUM(days(1:(month_of_year-1)))))
+
+          ENDIF
+
+
+       ELSE
+
+          !> Condition when date_init is provided but it is given in the wrong format
+          message_string = 'date_init not provided in the namelist or'            //          &
+                              ' given in the wrong format: MUST BE DDMMYYYY'                  
+          CALL message( 'init_date_and_time', 'DT0102', 2, 2, 0, 6, 0 ) 
+
+       ENDIF
+
+
+    END SUBROUTINE init_date_and_time
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Calculate current date and time of the simulation 
+!------------------------------------------------------------------------------!
+ 
+    SUBROUTINE calc_date_and_time
+
+       IMPLICIT NONE
+
+!--    Variables Definition
+       INTEGER		   		:: i_mon       !< Index for going through the different months
+
+       !> Update simulation time in seconds
+       time_update = simulated_time-coupling_start_time
+
+!--    Calculate current day of the simulated time
+       days_since_reference_point=INT(FLOOR( (time_utc_init + time_update) &
+                               / 86400.0_wp ) )
+
+!--    Calculate actual UTC time                        
+       time_utc = MOD((time_utc_init + time_since_reference_point), 86400.0_wp)
+       
+!sB    PRILIMINARY workaround for time_utc changes due to changes in time_since_reference_point in
+!sB    radiation_model_mod during runtime:
+       time_utc_emis = MOD((time_utc_init + time_update), 86400.0_wp)     
+
+!--    Calculate initial day of the year: it is calculated only once. In fact, day_of_year_init is initialized to 0 and then a positive value is passed. This condition is also called only when day_of_year_init is not given in the namelist. 
+
+       IF ( day_of_year_init == 0 ) THEN
+
+          !> Condition for printing an error when date_init is not provided when day_of_year_init is not given in the namelist or when the format of the date is not the one required by PALM. 
+          IF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+        
+             IF ( month_of_year == 1 ) THEN  !!month of year is read in input
+
+                day_of_year_init = day_of_month
+
+             ELSE
+
+                day_of_year_init= SUM(days( 1:(month_of_year-1) )) + day_of_month  !day_of_month is read in input in this case
+
+             ENDIF
+!kanani: Revise, we cannot force users to provide date_init, maybe set a default value?
+!           ELSE
+! 
+!              message_string = 'date_init not provided in the namelist or'             //          &
+!                               ' given in the wrong format: MUST BE DDMMYYYY'                        
+!              CALL message( 'calc_date_and_time', 'DT0100', 2, 2, 0, 6, 0 ) 
+     
+          ENDIF
+
+       ENDIF
+
       !-- Calculate actual hour of the day: the first hour of the day is from 00:00:00 to 00:59:59. 
 
@@ -302,8 +422,42 @@
 
       ENDIF       
-      
+
     END SUBROUTINE calc_date_and_time
 
-!TBD: check the routines used for update of emission indices in the DEFAULT MODE 
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> This routine determines the time factor index in the PRE-PROCESSED emissions mode.
+!------------------------------------------------------------------------------!
+
+ SUBROUTINE time_preprocessed_indices(index_hh)
+
+    USE indices
+
+    IMPLICIT NONE
+
+!
+!-- In/output
+    INTEGER, INTENT(INOUT) ::  index_hh    !> Index Hour
+!
+!-- Additional Variables for calculateing indices
+!-- Constants
+    INTEGER, PARAMETER ::  nhour = 24
+
+    IF (days_since_reference_point == 0) THEN
+
+       index_hh=hour_of_day
+
+    ELSE
+
+       index_hh=(days_since_reference_point*nhour)+(hour_of_day)
+
+    ENDIF
+
+
+ END SUBROUTINE time_preprocessed_indices
+
+
 !------------------------------------------------------------------------------!
 ! Description:
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 3454)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 3458)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, basit:
+! bug fixed in chemistry profiles
+! 
+! 3452 2018-10-30 13:13:34Z schwenkel
 ! Bugfix for profiles output
 ! 
@@ -1843,8 +1847,11 @@
        ENDIF
 
-       IF ( air_chemistry .AND. max_pr_cs > 0 )  THEN
+       IF ( air_chemistry  .AND.  max_pr_cs > 0 )  THEN
           IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-             CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+1,0), sums(nzb,pr_palm+1), &
-                                 nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
+             DO  i = 1, max_pr_cs
+                CALL MPI_ALLREDUCE( sums_l(nzb,pr_palm+max_pr_user+i,0),       &
+                                    sums(nzb,pr_palm+max_pr_user+i),           &
+                                    nzt+2-nzb, MPI_REAL, MPI_SUM, comm2d, ierr )
+             ENDDO
        ENDIF
 
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 3454)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 3458)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, basit:
+! bug fixed in sums and sums_l for chemistry profile output
+! 
+! 3448 2018-10-29 18:14:31Z kanani
 ! Add biometeorology
 ! 
@@ -711,6 +715,6 @@
               ngp_2dh_s_inner_l(nzb:nzt+1,0:statistic_regions),                &
               rmask(nysg:nyng,nxlg:nxrg,0:statistic_regions),                  &
-              sums(nzb:nzt+1,pr_palm+max_pr_user),                             &
-              sums_l(nzb:nzt+1,pr_palm+max_pr_user,0:threads_per_task-1),      &
+              sums(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs),                   &
+              sums_l(nzb:nzt+1,pr_palm+max_pr_user+max_pr_cs,0:threads_per_task-1),      &
               sums_l_l(nzb:nzt+1,0:statistic_regions,0:threads_per_task-1),    &
               sums_wsts_bc_l(nzb:nzt+1,0:statistic_regions),                   &
Index: palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3454)
+++ palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3458)
@@ -25,4 +25,14 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, banzhafs, Russo:
+! Uncommented lines on dimension of surface_fractions
+! Removed par_emis_time_factor variable, moved to chem_emissions_mod
+! Initialized nspec and other emission variables at time of declaration
+! Modified EXPERT mode to PRE-PROCESSED mode
+! Introduced Chemistry static netcdf file
+! Added the routine for reading-in netcdf data for chemistry
+! Added routines to get_variable interface specific for chemistry files
+! 
+! 3429 2018-10-25 13:04:23Z knoop
 ! add default values of origin_x/y/z
 ! 
@@ -368,8 +378,8 @@
 
        !-DIMENSIONS
-       INTEGER(iwp)                                 :: nspec                     !< number of chem species for which emission values are provided
-       INTEGER(iwp)                                 :: ncat                      !< number of emission categories
-       INTEGER(iwp)                                 :: nvoc                      !< number of VOCs components
-       INTEGER(iwp)                                 :: npm                       !< number of PMs components
+       INTEGER(iwp)                                 :: nspec=0                   !< number of chem species for which emission values are provided
+       INTEGER(iwp)                                 :: ncat=0                    !< number of emission categories
+       INTEGER(iwp)                                 :: nvoc=0                    !< number of VOCs components
+       INTEGER(iwp)                                 :: npm=0                     !< number of PMs components
        INTEGER(iwp)                                 :: nnox=2                    !< number of NOx components: NO and NO2
        INTEGER(iwp)                                 :: nsox=2                    !< number of SOx components: SO and SO4
@@ -391,7 +401,4 @@
        INTEGER(iwp),ALLOCATABLE, DIMENSION(:)       :: species_index             !< Index of emission chem species
 
-       REAL(wp), DIMENSION(24)                      :: par_emis_time_factor      !< time factors 
-                                                                                 !  for the parameterized mode: these are fixed for each hour
-                                                                                 !  of a single day.
        REAL(wp),ALLOCATABLE, DIMENSION(:)           :: xm                        !< Molecular masses of emission chem species
 
@@ -928,7 +935,4 @@
          ENDDO
 
-          !Assign Constant Values of time factors:
-          emt_att%par_emis_time_factor( : ) = (/ 0.01, 0.01, 0.01, 0.02, 0.03, 0.07, 0.09, 0.09, 0.05, 0.03, 0.03, 0.03, &
-                                                 0.03, 0.03, 0.03, 0.04, 0.05, 0.09, 0.09, 0.09, 0.04, 0.02, 0.01, 0.01 /)
 
        !> DEFAULT AND PRE-PROCESSED MODE
Index: palm/trunk/SOURCE/palm.f90
===================================================================
--- palm/trunk/SOURCE/palm.f90	(revision 3454)
+++ palm/trunk/SOURCE/palm.f90	(revision 3458)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! from chemistry branch r3443, forkel:
+! removed double do_emis check around CALL chem_init
+! replaced call to calc_date_and_time to init_date_and_time
+! 
+! 3337 2018-10-12 15:17:09Z kanani
 ! (from branch resler)
 ! Fix chemistry call
@@ -436,7 +441,6 @@
 
        CALL chem_init
+
 !       CALL photolysis_init   ! probably also required for restart
-
-       CALL init_date_and_time     !initialize the time of chemistry emissions
 
     ENDIF
@@ -448,5 +452,7 @@
 !
 !-- Initialize all necessary variables
-    CALL calc_date_and_time !this is required for chemistry emissions
+!
+!-- Initial time for chem_emissions_mod
+    CALL init_date_and_time
 
     CALL init_3d_model
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 3454)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 3458)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! remove duplicate USE chem_modules
+! from chemistry branch r3443, banzhafs, basit:
+! chem_depo call introduced
+! code added for decycling chemistry
+!
+! 3386 2018-10-19 16:28:22Z gronemeier
 ! Renamed tcm_prognostic to tcm_prognostic_equations
 ! 
@@ -340,17 +346,15 @@
     USE buoyancy_mod,                                                          &
         ONLY:  buoyancy
-
-    USE chemistry_model_mod,                                                   &
-        ONLY:  chem_integrate, chem_species,  chem_prognostic_equations,       &
-               nspec, nvar, spc_names, chem_boundary_conds
            
     USE chem_modules,                                                          &
-        ONLY:  call_chem_at_all_substeps, chem_gasphase_on
+        ONLY:  call_chem_at_all_substeps, chem_gasphase_on, cs_name, do_depo
 
     USE chem_photolysis_mod,                                                   &
         ONLY:  photolysis_control
 
-    USE chem_modules,                                                          &
-        ONLY:  call_chem_at_all_substeps, chem_gasphase_on, cs_name
+    USE chemistry_model_mod,                                                   &
+        ONLY:  chem_boundary_conds, chem_depo, chem_integrate,                 &
+               chem_prognostic_equations, chem_species,                        &
+               nspec, nvar, spc_names
 
     USE control_parameters,                                                    &
@@ -495,6 +499,9 @@
 
                 IF ( intermediate_timestep_count == 1 .OR.                        &
-                     call_chem_at_all_substeps ) THEN
-                   CALL chem_integrate (i,j)                                                
+                     call_chem_at_all_substeps )  THEN
+                   CALL chem_integrate (i,j)
+                   IF ( do_depo )  THEN
+                      CALL chem_depo(i,j)
+                   ENDIF
                 ENDIF
              ENDDO
